'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _Subject2 = require('rxjs/Subject');

var _Subscriber = require('rxjs/Subscriber');

var _Subscription = require('rxjs/Subscription');

var _ReplaySubject = require('rxjs/ReplaySubject');

var _Observable = require('rxjs/Observable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StreamSubject = function (_Subject) {
  (0, _inherits3.default)(StreamSubject, _Subject);

  function StreamSubject(optionsOrSource, destination) {
    (0, _classCallCheck3.default)(this, StreamSubject);

    if (destination instanceof _Observable.Observable) {
      var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(StreamSubject).call(this, destination, optionsOrSource));

      return (0, _possibleConstructorReturn3.default)(_this);
    }

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(StreamSubject).call(this));

    _this.options = optionsOrSource;
    _this.stream = null;
    _this.observers = null;
    _this.openObserver = optionsOrSource.openObserver;
    _this.closeObserver = optionsOrSource.closeObserver;
    _this.closingObserver = optionsOrSource.closingObserver;

    _this.destination = new _ReplaySubject.ReplaySubject();
    return (0, _possibleConstructorReturn3.default)(_this);
  }

  (0, _createClass3.default)(StreamSubject, [{
    key: 'lift',
    value: function lift(operator) {
      var subj = new StreamSubject(this, this.destination);

      subj.operator = operator;

      return subj;
    }
  }, {
    key: '_unsubscribe',
    value: function _unsubscribe() {
      this.options = null;
      this.destination = new _ReplaySubject.ReplaySubject();
      this.isStopped = false;
      this.hasErrored = false;
      this.hasCompleted = false;
      this.observers = null;
      this.isUnsubscribed = false;
    }
  }, {
    key: '_subscribe',
    value: function _subscribe(subscriber) {
      var _this2 = this;

      if (!this.observers) {
        this.observers = [];
      }

      var subscription = (0, _get3.default)((0, _getPrototypeOf2.default)(StreamSubject.prototype), '_subscribe', this).call(this, subscriber);
      var hasSource = function hasSource() {
        return _this2.source || !subscription || subscription.isUnsubscribed;
      };

      if (hasSource()) {
        return subscription;
      }

      if (this.options && !this.stream) {
        this.stream = this.options.createStream();
        var createSubscription = function createSubscription() {
          if (_this2.openObserver) {
            _this2.openObserver.next(_this2.stream);
          }

          var queue = _this2.destination;

          _this2.destination = _Subscriber.Subscriber.create(function (x) {
            return _this2.stream.writable !== false && _this2.stream.write(x);
          }, function () {
            if (_this2.closingObserver) {
              _this2.closingObserver.next(undefined);
            }

            _this2.stream.destroy();
          }, function () {
            if (_this2.closingObserver) {
              _this2.closingObserver.next(undefined);
            }
            _this2.stream.destroy();
          });

          if (queue && queue instanceof _ReplaySubject.ReplaySubject) {
            subscription.add(queue).subscribe(_this2.destination);
          }
        };

        if (this.options.openEvent) {
          this.stream.on(this.options.openEvent, createSubscription);
        } else {
          createSubscription();
        }

        this.stream.on('error', function (e) {
          return _this2.error(e);
        });
        this.stream.on(this.options.endEvent, function () {
          if (_this2.closeObserver) {
            _this2.closeObserver.next(undefined);
          }

          _this2._finalComplete();
        });
        this.stream.on(this.options.dataEvent, function (data) {
          return _this2._finalNext(data);
        });
      }

      return new _Subscription.Subscription(function () {
        subscription.unsubscribe();

        if (!_this2.observers || !_this2.observers.length) {
          if (_this2.stream) {
            _this2.stream.destroy();
          }

          _this2.stream = undefined;
          _this2.source = undefined;
          _this2.destination = new _ReplaySubject.ReplaySubject();
        }
      });
    }
  }]);
  return StreamSubject;
}(_Subject2.Subject);

exports.default = StreamSubject;