var Rx = require('rxjs/Rx')
require('rxjs/add/operator/skipUntil')
var SocketSubject = require('./dist/socket-subject').default

var s = new SocketSubject({
  host: 'topaxi.ch',
  port: 443,
  tls: true
})
console.log(s)

s.next('GET / HTTP/1.1\r\n')
s.next('Host: topaxi.ch\r\n')
s.next('Connection: close\r\n')
s.next('\r\n')

s
  .skipUntil(s.filter(function(chunk) {
    console.log({ chunk: chunk.toString() })
    return chunk === '\r\n'
  }))
  .reduce(function(responseBody, chunk) { return responseBody + chunk }, '')
  .subscribe(function(responseBody) {
    console.log(responseBody)
  })
